/*
 * guiHandler.java
 *
 * Created on July 14, 2006, 9:43 AM
 *
 *  Virtual Fight. A programming game.
 *  This class accept GUI connections, and send messages to them.
 *
 *  Copyright (C) 2006  Aidin Gharibnavaz.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

package virtualfight.GUI;

/**
 *
 * @author Aidin Gharibnavaz
 *          (aidin.vf@gmail.com)
 */

import virtualfight.map.Map;

import java.net.ServerSocket;
import java.net.Socket;
import java.io.PrintWriter;

public class guiHandler extends Thread{
    
    Socket[] GUISock;
    Map map;
    
    public guiHandler(int maxGUIs,Map map) {
        GUISock = new Socket[maxGUIs];
        this.map=map;
    }
    
    /*
     * Accept GUI connections.
     */
    public void run(){
        
        try{
            ServerSocket serverSock = new ServerSocket(4550);
            
            for (int i=0;i<GUISock.length;i++){
                GUISock[i] = serverSock.accept();
                System.out.println("/---------------------------");
                System.out.println("/GUI connection from "+
                        GUISock[i].getInetAddress().getHostAddress());
                System.out.println("/---------------------------");
                //Send size of the map to the GUI.
                PrintWriter output=
                    new PrintWriter(GUISock[i].getOutputStream(),true);
                output.println(this.map.height+","+this.map.width);
            }
            
        }catch (Exception e){
            System.out.println(e);
        }
    }
    
    /*
     * Send new position of charachters and objects to GUIs.
     */
    public void updateGUIs(){
        sendGUIs(this.map.getObjectPositions());
    }
    
    /*
     * Send message to all GUIs.
     */      
    private void sendGUIs(String message){
        //It loop until reach an empty GUISock.
        for (int i=0;GUISock[i]!=(null);i++){
            try{
            PrintWriter output=
                    new PrintWriter(GUISock[i].getOutputStream(),true);
            output.println(message);
            }catch (Exception e){
                System.out.println(e);
            }
        }
    }
}
