/*
 * Charachter.java
 *
 * Created on July 2, 2006, 9:18 AM
 *
 *  Virtual Fight. A programming game.
 *  Copyright (C) 2006  Aidin Gharibnavaz.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

package virtualfight.group;

/**
 * @author Aidin Gharibnavaz
 *         (aidin.vf@gmail.com)
 */
public class Charachter {
    
    public int[] location=new int[2];
    private boolean allowMoving=false;
    private String  dir;
    private boolean dead=false;
    
    public Charachter(int ylocation,int xlocation) {
        this.location[0]=ylocation;
        this.location[1]=xlocation;
        //Set the Charachter direction to up.
        //This is default value when game start.
        this.dir="UP";
    }
    
    public void setLocation(int ylocation,int xlocation,String direction){
        this.location[0]=ylocation;
        this.location[1]=xlocation;
        this.dir=direction;
    }
    
    /*
     * Return Charachter location in String format.
     * When a client request a charachter position,
     * then we call this method, and send location
     * for the client.
     * It will call from Group.java
     */
    public String getLocation(){
        return (location[0]+","+location[1]);
    }
    
    /*
     * Give and set 'allowMoving'
     * If 'allowMoving=true', this charachter can move.
     * If this charachter moved before, or died, it can't move
     * again.
     */
    public boolean getAllowMoving(){
        return this.allowMoving;
    }
    public void setAllowMoving(boolean allow){
        this.allowMoving=allow;
    }
    
    /*
     * Give and set 'dead'.
     */
    public boolean isDead(){
        return this.dead;
    }
    public void dead(){
        this.dead=true;
    }
    
    /*
     * Give and set this charachter direction.
     */
    public String getDirection(){
        return dir;
    }
    public void setDirection(String direction){
        this.dir=direction;
    }
}
